#ifndef INCG_AUTEST_H_
#define INCG_AUTEST_H_

/**
 * @brief	eXg}N
 * @{
*/

#define AUTEST_ASSERT_TRUE(statement, ...)		AUTEST_ASSERT_TRUE(statement, #statement, __FILE__, __LINE__)
#define AUTEST_EXPECT_TRUE(statement, ...)		AUTEST_EXPECT_TRUE(statement, #statement, __FILE__, __LINE__)

#define AUTEST_ASSERT_FALSE(statement, ...)		AUTEST_ASSERT_FALSE(statement, #statement, __FILE__, __LINE__)
#define AUTEST_EXPECT_FALSE(statement, ...)		AUTEST_EXPECT_FALSE(statement, #statement, __FILE__, __LINE__)

#define AUTEST_ASSERT_EQ(expected, actual)		AUTEST_ASSERT_EQ(expected, actual, #expected, #actual, __FILE__, __LINE__)
#define AUTEST_EXPECT_EQ(expected, actual)		AUTEST_EXPECT_EQ(expected, actual, #expected, #actual, __FILE__, __LINE__)
#define AUTEST_ASSERT_NE(val1, val2)			AUTEST_ASSERT_NE(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_EXPECT_NE(val1, val2)			AUTEST_EXPECT_NE(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_ASSERT_LT(val1, val2)			AUTEST_ASSERT_LT(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_EXPECT_LT(val1, val2)			AUTEST_EXPECT_LT(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_ASSERT_LE(val1, val2)			AUTEST_ASSERT_LE(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_EXPECT_LE(val1, val2)			AUTEST_EXPECT_LE(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_ASSERT_GT(val1, val2)			AUTEST_ASSERT_GT(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_EXPECT_GT(val1, val2)			AUTEST_EXPECT_GT(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_ASSERT_GE(val1, val2)			AUTEST_ASSERT_GE(val1, val2, #val1, #val2, __FILE__, __LINE__)
#define AUTEST_EXPECT_GE(val1, val2)			AUTEST_EXPECT_GE(val1, val2, #val1, #val2, __FILE__, __LINE__)


#define AUTEST_ASSERT_STREQ(str1, str2, ...)	AUTEST_ASSERT_STREQ(str1, str2, #str1, #str2, __FILE__, __LINE__)
#define AUTEST_EXPECT_STREQ(str1, str2, ...)	AUTEST_EXPECT_STREQ(str1, str2, #str1, #str2, __FILE__, __LINE__)
#define AUTEST_ASSERT_STRNE(str1, str2, ...)	AUTEST_ASSERT_STRNE(str1, str2, #str1, #str2, __FILE__, __LINE__)
#define AUTEST_EXPECT_STRNE(str1, str2, ...)	AUTEST_EXPECT_STRNE(str1, str2, #str1, #str2, __FILE__, __LINE__)

#define AUTEST_ASSERT_STRCASEEQ(str1, str2, ...)	AUTEST_ASSERT_STRCASEEQ(str1, str2, #str1, #str2, __FILE__, __LINE__)
#define AUTEST_EXPECT_STRCASEEQ(str1, str2, ...)	AUTEST_EXPECT_STRCASEEQ(str1, str2, #str1, #str2, __FILE__, __LINE__)
#define AUTEST_ASSERT_STRCASENE(str1, str2, ...)	AUTEST_ASSERT_STRCASENE(str1, str2, #str1, #str2, __FILE__, __LINE__)
#define AUTEST_EXPECT_STRCASENE(str1, str2, ...)	AUTEST_EXPECT_STRCASENE(str1, str2, #str1, #str2, __FILE__, __LINE__)

/**
 * @}
*/

#endif
